<template>
  <div class="relative my-2">
    <div style="height: 70vh" id="mapMountPoint" />
    <vue-bottom-sheet
      v-if="activeElement"
      ref="myBottomSheet"
      class="md:hidden"
      max-height="50%"
      :background-scrollable="false"
    >
      <event-result
        v-if="activeElement.creator || activeElement.group"
        :event="activeElement"
        :has-border="false"
        view-mode="column"
      />
      <group-result
        v-else
        :group="activeElement"
        :has-border="false"
        view-mode="column"
      />
    </vue-bottom-sheet>
    <div
      class="absolute hidden md:block bottom-0 md:top-2 right-0 h-48 w-full md:w-80 overflow-y-visible text-white [box-shadow:0 6px 9px 2px rgba(119,119,119,.75)] -my-4 px-2 z-[1100]"
      v-if="activeElement"
    >
      <event-result
        v-if="activeElement.creator || activeElement.group"
        :event="activeElement"
        view-mode="column"
        :has-border="false"
      />
      <group-result
        v-else
        :group="activeElement"
        :has-border="false"
        view-mode="column"
      />
    </div>
  </div>
</template>

<script setup lang="ts">
  import 'leaflet/dist/leaflet.css'
  import calendarIcon from '../icons/calendar.svg?raw'
  import groupIcon from '../icons/group.svg?raw'
  import pinIcon from '../icons/pin-alt.svg?raw'
  import {
    computed,
    inject,
    onBeforeUnmount,
    onMounted,
    PropType,
    ref,
    watch,
  } from 'vue'
  import { searchEventMarkers, searchGroupMarkers } from '@/shared/search'
  import { buildEventMarkerSearchQuery } from '@/query/buildQuery'
  import VueBottomSheet from './map/vue-bottom-sheet.vue'
  import {
    map,
    LatLng,
    LatLngBounds,
    Layer,
    LeafletMouseEvent,
    tileLayer,
    geoJSON,
    marker,
    point,
    divIcon,
    Map,
    GeoJSON,
  } from 'leaflet'
  import { MarkerClusterGroup } from 'leaflet.markercluster/src'
  import { Feature, GeoJsonProperties, Point } from 'geojson'
  import { SearchFormData } from '@/query/misc'
  import { Locale } from 'date-fns'
  import { ContentType } from '@/models'
  import { EnhancedEvent } from '../../../server/types/event.model'
  import { EnhancedGroup } from '../../../server/types/group.model'
  import EventResult from '@/components/result/EventResult.vue'
  import GroupResult from '@/components/result/GroupResult.vue'
  import { useGettext } from 'vue3-gettext'

  const geojsonEventData = ref(null)
  const geojsonGroupData = ref(null)
  const mapElement = ref<Map>(null)
  const geojsonEventElement = ref<GeoJSON>(null)
  const geojsonGroupElement = ref<GeoJSON>(null)
  const markers = ref(null)
  const myBottomSheet = ref(null)

  const props = defineProps({
    formData: {
      type: Object as PropType<SearchFormData>,
      required: true,
    },
  })

  const formData = computed(() => props.formData)

  const activeElement = ref<EnhancedEvent | EnhancedGroup>(null)

  const { $gettext } = useGettext()

  watch(formData, update, { deep: true })

  const dateFnsLocale = inject<Locale>('dateFnsLocale')

  function setGeojson() {
    if (
      !geojsonEventElement.value ||
      !geojsonGroupElement.value ||
      !markers.value
    ) {
      return
    }
    geojsonEventElement.value.clearLayers()
    geojsonGroupElement.value.clearLayers()
    markers.value.clearLayers()
    if (formData.value.contentType !== ContentType.GROUPS) {
      geojsonEventElement.value.addData(geojsonEventData.value)
    }
    if (formData.value.contentType !== ContentType.EVENTS) {
      geojsonGroupElement.value.addData(geojsonGroupData.value)
    }
    markers.value.addLayers([
      geojsonEventElement.value,
      geojsonGroupElement.value,
    ])
    markers.value.refreshClusters()
  }

  async function update() {
    if (!mapElement.value || !mapElement.value.getBounds) return
    const rawBounds: LatLngBounds = mapElement.value.getBounds()
    const bounds: LatLngBounds = mapElement.value.wrapLatLngBounds(rawBounds)
    if (
      bounds.getNorthWest().lat === 0 ||
      bounds.getNorthWest().lat === bounds.getSouthEast().lat
    )
      return
    const zoom = mapElement.value.getZoom()
    const query = buildEventMarkerSearchQuery(
      {
        ...formData.value,
        distance: undefined,
        latlon: undefined,
        zoom,
        bbox: `${bounds.getNorthWest().lat}, ${bounds.getNorthWest().lng}:${
          bounds.getSouthEast().lat
        }, ${bounds.getSouthEast().lng}`,
        locale: dateFnsLocale,
      },
      $gettext
    )
    geojsonEventData.value = await searchEventMarkers(query)
    geojsonGroupData.value = await searchGroupMarkers({
      ...query,
      sort: undefined,
    })
    setGeojson()
  }

  onBeforeUnmount(() => {
    if (mapElement.value) {
      mapElement.value.remove()
    }
  })

  onMounted(async () => {
    mapElement.value = map('mapMountPoint').setView([0, 0], 3)
    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
    // @ts-ignore
    mapElement.value._onResize()
    mapElement.value.on('click', () => {
      activeElement.value = null
      if (myBottomSheet.value) {
        myBottomSheet.value.close()
      }
    })
    // mapElement.value.on('load', function () {
    //   console.debug('load event')
    //   setTimeout(() => {
    //     console.debug('invalidate size')
    //     mapElement.value.invalidateSize()
    //   }, 1000)
    // })
    markers.value = new MarkerClusterGroup({ chunkedLoading: true })

    mapElement.value.on('zoom', update)
    mapElement.value.on('moveend', update)

    const onEachFeature = (feature: Feature<Point>, layer: Layer) => {
      if (!feature.properties.point_count) {
        layer.on('click', () => {
          activeElement.value = feature.properties as
            | EnhancedEvent
            | EnhancedGroup
          if (myBottomSheet.value) {
            myBottomSheet.value.open()
          }
        })
      } else {
        layer.on('click', (e) => loadCluster(e as LeafletMouseEvent))
      }
    }

    const categoryToColorClass = (properties: GeoJsonProperties): string => {
      if (properties.creator || properties.group) {
        return 'marker-event'
      }
      return 'marker-group'
    }

    const pointToLayer = (feature: Feature<Point>, latlng: LatLng): Layer => {
      if (!feature.properties.point_count) {
        const icon = divIcon({
          html: `<div class="marker-container ${categoryToColorClass(
            feature.properties
          )}">
            <div class="pin-icon-container">
              ${pinIcon}
            </div>
            <div class="element-icon-container">
              ${
                feature.properties.creator || feature.properties.group
                  ? calendarIcon
                  : groupIcon
              }
            </div>
          </div>`,
          iconSize: [50, 50],
          iconAnchor: [25, 50],
          // iconSize: [
          //   MARKER_TOUCH_TARGET_SIZE * 0.5,
          //   MARKER_TOUCH_TARGET_SIZE * 0.5,
          // ],
        })
        return marker(latlng, { icon })
      }

      const count = feature.properties.point_count
      const size = count < 100 ? 'small' : count < 1000 ? 'medium' : 'large'
      const icon = divIcon({
        html: `<div><span>${feature.properties.point_count}</span></div>`,
        className: 'server-clusters marker-cluster marker-cluster-' + size,
        iconSize: point(40, 40),
      })

      return marker(latlng, {
        icon,
      })
    }

    tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
      attribution:
        '&copy; <a href="https://osm.org/copyright">OpenStreetMap</a> contributors',
      className: 'map-tiles',
    }).addTo(mapElement.value)
    await update()
    geojsonEventElement.value = geoJSON(geojsonEventData.value, {
      onEachFeature,
      pointToLayer,
    })
    markers.value.addLayer(geojsonEventElement.value)
    geojsonGroupElement.value = geoJSON(geojsonGroupData.value, {
      onEachFeature,
      pointToLayer,
    })
    markers.value.addLayer(geojsonGroupElement.value)
    mapElement.value.addLayer(markers.value)

    async function loadCluster(e: LeafletMouseEvent) {
      if (e?.target?.feature?.properties?.key && e?.latlng) {
        const [zoom] = e.target.feature.properties.key.split('/')
        const center = e.latlng
        mapElement.value.flyTo(center, parseInt(zoom, 10))
      } else {
        // e.layer.openPopup()
      }
    }
  })
</script>
<style>
  /*
* https://github.com/mapbox/supercluster/blob/f073fade1caae0b2b1beffd013b74ff024ff413b/demo/cluster.css
*/
  .marker-cluster-small {
    background-color: rgba(181, 226, 140, 0.6);
  }

  .marker-cluster-small div {
    background-color: rgba(110, 204, 57, 0.6);
  }

  .marker-cluster-medium {
    background-color: rgba(241, 211, 87, 0.6);
  }

  .marker-cluster-medium div {
    background-color: rgba(240, 194, 12, 0.6);
  }

  .marker-cluster-large {
    background-color: rgba(253, 156, 115, 0.6);
  }

  .marker-cluster-large div {
    background-color: rgba(241, 128, 23, 0.6);
  }

  .marker-cluster {
    background-clip: padding-box;
    border-radius: 20px;
  }

  .marker-cluster div {
    width: 30px;
    height: 30px;
    margin-left: 5px;
    margin-top: 5px;

    text-align: center;
    border-radius: 15px;
    font: 12px 'Helvetica Neue', Arial, Helvetica, sans-serif;
  }

  .marker-cluster span {
    line-height: 30px;
  }

  :root {
    --map-tiles-filter: brightness(0.6) invert(1) contrast(3) hue-rotate(200deg)
      saturate(0.3) brightness(0.7);
  }

  @media (prefers-color-scheme: dark) {
    .map-tiles {
      filter: var(--map-tiles-filter, none);
    }
  }

  .leaflet-div-icon {
    background: none !important;
    border: none !important;
  }

  .marker-container {
    position: relative;
  }

  .marker-container.marker-event svg {
    fill: yellow;
    color: black;
  }

  .marker-container.marker-group svg {
    fill: lightblue;
    color: white;
  }

  .pin-icon-container {
    position: absolute;
    width: 50px;
    height: 50px;
  }

  .pin-icon-container svg path {
    stroke-width: 1;
  }

  .pin-icon-container svg {
    width: 100%;
    height: 100%;
  }

  .element-icon-container {
    position: absolute;
    transform: translate(12px, 8px);
  }
</style>
